from keras.models import model_from_json
from writer import write_data, writematfile
import numpy as np
import scipy.io
from keras import backend as K
def evaluatemodel(model,val,test, train, path, write=False):
    train_pred = model.predict(train[0][:-2])
    train_metrics = model.evaluate(train[0][:-2],train[1])
    val_pred = model.predict(val[0][:-2])
    validation_metrics = model.evaluate(val[0][:-2],val[1])
    test_pred = model.predict(test[0][:-2])
    test_metrics = model.evaluate(test[0][:-2],test[1])
    print("validation_metrics:",validation_metrics)
    print("test_metrics:",test_metrics)
    layer_dict = dict([(layer.name, layer) for layer in model.layers[1:]])
    code_layer_output_node = layer_dict['code_layer'].output
    code_layer_fn = K.function(model.input, [code_layer_output_node])
    train_pred_code_layer = code_layer_fn(train[0][:-2])
    val_pred_code_layer = code_layer_fn(val[0][:-2])
    test_pred_code_layer = code_layer_fn(test[0][:-2])
    if write:
        print('************** Writing the data ***************')
        writematfile(path,val,val_pred, val_pred_code_layer,'val')
        writematfile(path,test,test_pred, test_pred_code_layer,'test')
        writematfile(path,train,train_pred, train_pred_code_layer,'train')
        write_data(path,val,val_pred)
        write_data(path,test,test_pred)